Attribute VB_Name = "Primary"
Option Explicit

'////////////////// Public VARIABLES ////////////////////////////////////
Public cFile                    As New cFile                    ' these are utility classes
Public cUtil                    As New cUtility
Public cMall                    As New CAdminMall               ' from commerce admin lib
Public cFiles                   As New CAdminFiles              ' ditto
Public gsTemplatePath           As String                       ' the path to the template directory, will change after we xcopy the new template
Public gsStoreShortName         As String                       ' the new short name selected for the store, also the new template name
Public gsTemplateStore          As String
Public fAbout                   As Boolean                      ' true if we want to include an about page
Public db                       As Database
Public gRS                      As Recordset                    ' the main table

' These are scratch variables and are used throughout the app to hold temp data
Public v                        As Variant
Public byt                      As Byte
Public s                        As String
Public i                        As Integer
Public col                      As New Collection                ' set to nothing when done...

'////////////////// Public CONSTANTS ////////////////////////////////////
Public Const MSG_CAPTION        As String = "Commerce Clone Wizard "      ' ditto
Public Const WACK               As String = "\"
Public Const FORE_WACK          As String = "/"
Public Const COMMA              As String = ","
Public Const TILDE              As String = "~"
Public LOGO                     As String

 Sub Main()
        
    If App.PrevInstance Then
        MsgBox "An instance of this application is already loaded...closing down.", vbCritical, MSG_CAPTION
        End
    End If
    
    '// must have a logo.gif file in the app.path - assumed that the ISP will put their logo file here...
    LOGO = cFile.AddBackSlash(App.Path) & "Logo.gif"
    Call CheckForFile(LOGO)
    #If debugme Then
        frmChooseStore.Show
    #Else
        frmSplash.Show
        cUtil.CenterMe frmSplash
        frmSplash.Refresh
        cUtil.Wait 6
        frmChooseStore.Show
        Unload frmSplash
    #End If
    
    CheckService
    
End Sub

Sub ErrorTrap(lErrNumb As Long, sErrDescription As String, Optional sCallingFunction As String)
'***********************************************************************************************
' PURPOSE:      to display the error message to the client
' INPUTS:       all the data from the err object and the optional calling function or sub
' AUTHOR DATE:  brucej  Sept ' 97
' REV:          10/23/97  Testing has shown that some errors leave the app up in an unstable
'               state and so will just shut it down.
'***********************************************************************************************
On Error GoTo ErrorTrap_Err:
'***********************************************************************************************
Dim msg         As String
          
          msg = "Error" & vbCrLf
    msg = msg & "Error Number:        " & lErrNumb & vbCrLf
    msg = msg & "Error Description:   " & sErrDescription & vbCrLf
    If Not IsMissing(sCallingFunction) Then msg = msg & "Calling Function:    " & sCallingFunction
    MsgBox msg, vbOKOnly, MSG_CAPTION
           
    End

'***********************************************************************************************
ErrorTrap_bye:
    Exit Sub
ErrorTrap_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "ErrorTrap"
    GoTo ErrorTrap_bye
#End If
End Sub

Sub CheckForFile(sPathFileName As String)
'***********************************************************************************************
' PURPOSE:      checks to see if the file exists and if not, then notify and bail
' AUTHOR DATE:  brucej  Sept ' 97
' REV:
'***********************************************************************************************
On Error GoTo CheckForFile_Err:
'***********************************************************************************************

    If Not cFiles.Exists(sPathFileName) Then
        #If debugme Then
            Stop
        #Else
            s = "The file: " & vbCrLf & vbCrLf
            s = s & sPathFileName & vbCrLf & vbCrLf
            s = s & "does not exist.  Please locate and replace the file." & vbCrLf
            s = s & "Shutting Down."
            MsgBox s, vbCritical, MSG_CAPTION
            End
        #End If
    End If
    
'***********************************************************************************************
CheckForFile_bye:
    Exit Sub
CheckForFile_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "CheckForFile"
    GoTo CheckForFile_bye
#End If
End Sub

Sub CheckService()
' check to make sure the www service is stated
Const WEB_SERVICE   As String = "W3SVC"
Dim cServ           As New CAdminService
Dim vServices       As Variant
Dim v               As Variant
Dim fRunning        As Boolean          ' true if service is running
Dim msg             As String

    vServices = cServ.GetServicesNames(True)        ' get all running stores
    For Each v In vServices
        If v = WEB_SERVICE Then fRunning = True
    Next
    If fRunning = False Then
        msg = "The World Wide Web Service is not started on this computer." & vbCrLf & vbCrLf
        msg = msg & "Press " & Chr$(34) & "Yes" & Chr$(34) & " to start the service, or press "
        msg = msg & Chr$(34) & "No" & Chr$(34) & " to exit."
        If MsgBox(msg, vbYesNo + vbDefaultButton2, MSG_CAPTION) = vbYes Then
            With Screen.ActiveForm
                .MousePointer = vbHourglass
                .Refresh
                cServ.Service = WEB_SERVICE
                cServ.Start
                cUtil.Sleep 3
                'could check for successful service start here...
                .MousePointer = vbDefault
            End With
        Else
            End
        End If
    End If

End Sub

Sub UpdateNewSetupInDB(sNewValue As String, lkey As Long)
'***********************************************************************************************
' PURPOSE:      will write a value back to the db (set as global value)
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo UpdateNewSetupInDB_Err:
Dim sql                     As String
Dim rs                      As Recordset
'***********************************************************************************************
    Call cUtil.ReplaceString(sNewValue, Chr$(34), "'")
    sql = "UPDATE tblMain SET memNewSetup = " & Chr$(34) & sNewValue & Chr$(34) & " WHERE lKey=" & lkey & ";"
    db.Execute sql
'***********************************************************************************************
UpdateNewSetupInDB_bye:
    On Error Resume Next
    rs.Close: Set rs = Nothing
    Exit Sub
UpdateNewSetupInDB_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "UpdateNewSetupInDB"
    GoTo UpdateNewSetupInDB_bye
#End If
End Sub

Sub UpdateCurrentSetupInDB(sNewValue As String, lkey As Long)
'***********************************************************************************************
' PURPOSE:      will write a value back to the db (set as global value)
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo UpdateCurrentSetupInDB_Err:
Dim sql                     As String
Dim rs                      As Recordset
'***********************************************************************************************
    sql = "UPDATE tblMain SET memCurrentSetup = " & Chr$(34) & sNewValue & Chr$(34) & " WHERE lKey=" & lkey & ";"
    db.Execute sql
'***********************************************************************************************
UpdateCurrentSetupInDB_bye:
    On Error Resume Next
    rs.Close: Set rs = Nothing
    Exit Sub
UpdateCurrentSetupInDB_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "UpdateCurrentSetupInDB"
    GoTo UpdateCurrentSetupInDB_bye
#End If
End Sub

Sub ConfirmCancel()
    If MsgBox("Are you sure you want to exit the application?", vbOKCancel, MSG_CAPTION) = vbOK Then
        End
    End If
        
    
    
End Sub
