VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const WACK          As String = "\"

Friend Function GetFileFromPath(sFullPath As String) As String
'***********************************************************************************************
' PURPOSE:      returns the file from the full path
' INPUTS:       the full path such as c:\mydirectory\myfile.txt
' RETURNS:      the file name such as myfile.txt
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo GetFileFromPath_Err:
'***********************************************************************************************
Dim iLen            As String
Dim icntr           As Integer

    iLen = Len(Trim$(sFullPath))
    For icntr = iLen To 1 Step -1
        If Mid$(sFullPath, icntr, 1) = WACK Then
            GetFileFromPath = Mid$(sFullPath, icntr + 1)
            Exit Function
        End If
    Next

'***********************************************************************************************
GetFileFromPath_bye:
    Exit Function
GetFileFromPath_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "GetFileFromPath"
    GoTo GetFileFromPath_bye
#End If
End Function

Friend Function GetDirectoryFromPathFileName(sFullPath As String) As String
'***********************************************************************************************
' PURPOSE:      Returns the path sans the file name
' INPUTS:       the full path such as c:\mydirectory\myfile.txt
' RETURNS:      the directory info only such as c:\mydirectory\
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo GetDirectoryFrompathfilename_Err:
'***********************************************************************************************
Dim iLen            As Integer
Dim icntr           As Integer
    
    iLen = Len(Trim$(sFullPath))
    For icntr = iLen To 1 Step -1
        If Mid$(sFullPath, icntr, 1) = WACK Then
            GetDirectoryFromPathFileName = Left$(sFullPath, icntr - 1)
            Exit Function
        End If
    Next
    

'***********************************************************************************************
GetDirectoryFrompathfilename_bye:
    Exit Function
GetDirectoryFrompathfilename_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "GetDirectoryFrompathfilename"
    GoTo GetDirectoryFrompathfilename_bye
#End If
End Function

Friend Function AddBackSlash(ByVal vstrPath As String) As String
'***********************************************************************************************
' PURPOSE:      Will add ending backslash if not already there
' INPUTS:       the path to check e.g.: c:\mydirectory
'               NOTE: by val so original is not modified
' RETURNS:      the path with backslash e.g.: c:\mydirectory\
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo AddBackSlash_Err:
'***********************************************************************************************
    vstrPath = Trim$(vstrPath)                      ' get rid of leading and trailing spaces
    If Len(vstrPath) > 0 Then
        If Right$(vstrPath, 1) <> WACK Then vstrPath = vstrPath & WACK
    End If
    AddBackSlash = vstrPath

'***********************************************************************************************
AddBackSlash_bye:
    Exit Function
AddBackSlash_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "AddBackSlash"
    GoTo AddBackSlash_bye
#End If
End Function

Friend Function RemoveBackSlash(ByVal vstrPath As String, Optional bFront As Boolean) As String
'***********************************************************************************************
' PURPOSE:      removes a backslash at the end of the string UNLESS
'               the optional bFront flag is raised and then it only removes the backslash from the front
' INPUTS:       the vstrPath to change, NOTE - the original value is not changed
' RETURNS:      the modified string
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo Removebackslash_Err:
'***********************************************************************************************
    
    vstrPath = Trim$(vstrPath)
    If Len(vstrPath) > 0 Then
        If bFront Then
            If Left$(vstrPath, 1) = WACK Then vstrPath = Mid$(vstrPath, 2)
        Else
            If Right$(vstrPath, 1) = WACK Then vstrPath = Left$(vstrPath, (Len(vstrPath) - 1))
        End If
    End If
    RemoveBackSlash = vstrPath

'***********************************************************************************************
Removebackslash_bye:
    Exit Function
Removebackslash_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "Removebackslash"
    GoTo Removebackslash_bye
#End If
End Function
