VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cUtility"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const PROCESS_QUERY_INFORMATION              As Long = &H400
Private Const PROCESS_TERMINATE                      As Long = &H1
Private Const STILL_ACTIVE                           As Long = &H103
Private Const SYNCHRONIZE                            As Long = 1048576


Private Declare Function CloseHandle _
             Lib "kernel32" _
                        (ByVal hObject As Long) As Long

Private Declare Function OpenProcess _
            Lib "kernel32" _
                        (ByVal dwDesiredAccess As Long, _
                         ByVal bInheritHandle As Long, _
                         ByVal dwProcessId As Long) As Long
                     
Private Declare Function GetExitCodeProcess _
            Lib "kernel32" _
                        (ByVal hProcess As Long, _
                         lpExitCode As Long) As Long

Private Declare Function TerminateProcess _
            Lib "kernel32" _
                        (ByVal hProcess As Long, _
                         ByVal uExitCode As Long) As Long

Private Declare Function api_GetPrivateProfileString_StringKey _
            Lib "kernel32" Alias "GetPrivateProfileStringA" _
                        (ByVal lpApplicationName As String, _
                         ByVal lpKeyName As String, _
                         ByVal lpDefault As String, _
                         ByVal lpReturnedString As String, _
                         ByVal nSize As Long, _
                         ByVal lpFileName As String) As Long

Private Declare Function api_WritePrivateProfileString _
            Lib "kernel32" Alias "WritePrivateProfileStringA" _
                        (ByVal lpApplicationName As String, _
                         ByVal lpKeyName As Any, _
                         ByVal lpString As String, _
                         ByVal lpFileName As String) As Long

Private Declare Sub api_Sleep _
            Lib "kernel32" Alias "Sleep" _
                        (ByVal dwMilliseconds As Long)

Private Declare Function WaitForSingleObject _
            Lib "kernel32" _
                        (ByVal hHandle As Long, _
                         ByVal dwMilliseconds As Long) As Long

Public Sub Sleep(iSecs As Integer)
    'convert seconds to milliseconds
    iSecs = iSecs * 1000
    Call api_Sleep(iSecs)
End Sub

Friend Sub CenterMe(frm As Form)
'***********************************************************************************************
' PURPOSE:      will center on screen the form passed here
'               call like centerme(me)
' INPUTS:       a form to center
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo CenterMe_Err:
'***********************************************************************************************

    frm.Move (Screen.Width - frm.Width) / 2, (Screen.Height - frm.Height) / 2
    
'***********************************************************************************************
CenterMe_bye:
    Exit Sub
CenterMe_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "CenterMe"
    GoTo CenterMe_bye
#End If
End Sub

Friend Sub MirrorForm(frmCurrent As Form, frmNew As Form)
'***********************************************************************************************
' PURPOSE:      Will mirror the placement and size of an existing form
' INPUTS:       frmNew will mirror frmCurrent on size and screen placement when it opens
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo MirrorForm_Err:
'***********************************************************************************************
    
    frmNew.Move frmCurrent.Left, frmCurrent.Top, frmCurrent.Width, frmCurrent.Height
    frmCurrent.Hide
    frmNew.Show
    
'***********************************************************************************************
MirrorForm_bye:
    Exit Sub
MirrorForm_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "MirrorForm"
    GoTo MirrorForm_bye
#End If
End Sub

Friend Function ValidateBox(frmCall As Form, ctrlTextBox As Control) As Boolean
'***********************************************************************************************
' PURPOSE:      Will validate that the field passed here has something in it.
'               Uses the tag field to id
' INPUTS:       frmCall:        the form holding the controls
'               ctrlTextBox:    the text box to confirm
' RETURNS:      True if Error
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo ValidateBox_Err:
'***********************************************************************************************
    
    If ctrlTextBox = vbNullString Then
        MsgBox "You must enter a value in the " & ctrlTextBox.TAG & " field.", vbOKOnly, MSG_CAPTION
        frmCall.Controls(ctrlTextBox.Name).SetFocus
        ValidateBox = True
    End If

'***********************************************************************************************
ValidateBox_bye:
    Exit Function
ValidateBox_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "ValidateBox"
    GoTo ValidateBox_bye
#End If
End Function

Friend Function ReadIniFile _
                                (r_sAppName As String, _
                                 r_sKeyName As String, _
                                 r_sDefaultValue As String, _
                                 r_sIniFileName As String) As String
'********************************************************************************************************************
' PURPOSE:      reads ini file information
' INPUTS:       r_sAppName:         section header
'               r_skeyName:         the entry whose associated string is to be retrieved
'               r_sDefaultValue:    in case there is nothing in the registry, this will be the default
'               r_sIniFileName:     and path if necessary
' RETURNS:      the string value from the ini file
' CALLED FROM:  several places
' AUTHOR DATE:  brucej  07/10/96
'********************************************************************************************************************
Dim sReturn                     As String * 4098
Dim l                           As Long
On Error GoTo ReadIniFile_Err
'********************************************************************************************************************
    l = api_GetPrivateProfileString_StringKey(lpApplicationName:=r_sAppName, lpKeyName:=r_sKeyName, _
            lpDefault:=r_sDefaultValue, lpReturnedString:=sReturn, nSize:=4099, lpFileName:=r_sIniFileName)
    If l > 0 Then
        ReadIniFile = Left$(sReturn, l)
    Else
        ReadIniFile = vbNullString
    End If
'********************************************************************************************************************
ReadIniFile_bye:
    Exit Function
ReadIniFile_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "ReadIniFile"
    Exit Function
#End If
End Function

Friend Function WriteIniFile _
                                (r_sAppName As String, _
                                 r_sKeyName As String, _
                                 r_sString As String, _
                                 r_sIniFileName As String) As Boolean
'********************************************************************************************************************
' PURPOSE:      writes ini file information
' EFFECTS:      nothing
' INPUTS:       r_sAppName:         section header
'               r_skeyName:         the entry whose associated string is to be retrieved
'               r_sString:          string to write
'               r_sIniFileName:     and path if necessary
' RETURNS:      true if succcess
' CALLED FROM:  several places
' AUTHOR DATE:  brucej      09/26/96
'********************************************************************************************************************
Dim sReturn                     As String * 4098
Dim l                           As Long
On Error GoTo WriteIniFile_Err
'********************************************************************************************************************
    l = api_WritePrivateProfileString _
                                (lpApplicationName:=r_sAppName, _
                                 lpKeyName:=r_sKeyName, _
                                 lpString:=r_sString, _
                                 lpFileName:=r_sIniFileName)
    
    If l > 0 Then WriteIniFile = True
'********************************************************************************************************************
WriteIniFile_bye:
    Exit Function
WriteIniFile_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "WriteIniFile"
    Exit Function
#End If
End Function

Friend Function ParseToken(vstrString As String, vstrToken As String) As String
'***********************************************************************************************
' PURPOSE:      To parse a strString for the string to the vstrToken.  A common use for this would
' be a routine that would work like this:
'-----------------------------------------------------
'    Do until strSearchString = ""
'        Array(x) = ParseToken(strSearchString,";")
'    Loop
'-----------------------------------------------------
' or a better way is to use collections as:
'    Do Until s = vbNullString
'        cFiles.Add (ParseToken(s, vbNullChar))
'    Loop
'This function will change the value of strString each time it is called so should place any value
'that you need to keep the original in a temp string and pass the temp string
'*************************************************************************************************
' EFFECTS:      vstrString, changes it each time the program runs
' INPUTS:       vstrString:  string that has the values and tokens
'               vstrToken:  token value; e.g., ; or , or anything
' RETURNS:      The value before the token
' CALLED FROM:  Page
' AUTHOR DATE:  brucej  08/25/95
' REV:          Sept ' 97
'***********************************************************************************************
Dim i As Integer
On Error GoTo ParseToken_Err:
'***********************************************************************************************
    i = InStr(1, vstrString, vstrToken, 1)             ' case insenstive
    If i > 0 Then
        ParseToken = Left$(vstrString, i - 1)
        vstrString = Mid$(vstrString, i + 1)
    Else
        ParseToken = vstrString
        vstrString = vbNullString
    End If
'***********************************************************************************************
ParseToken_bye:
    Exit Function
ParseToken_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "ParseToken"
    GoTo ParseToken_bye
#End If
End Function

Friend Sub StripNull(s As String)
'***********************************************************************************************
' PURPOSE:      Strips the null from the end of the string
' INPUTS:       s:  is an input/output variable
' RETURNS:      the modified string back through s
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo StripNull_Err:
'***********************************************************************************************
Dim iLen            As Integer
'**********************************************************************************
    
    iLen = Len(s)
    If Right$(s, 1) = vbNullChar Then s = Left$(s, iLen - 1)

'***********************************************************************************************
StripNull_bye:
    Exit Sub
StripNull_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "StripNull"
    GoTo StripNull_bye
#End If
End Sub


Public Sub ReplaceString(sSourceIO As String, sSearchForString As String, sReplacementString As String)
'********************************************************************************************************************
' PURPOSE:      Changes the source string by replacing all of the target strings with objects
' EFFECTS:      the given string
' INPUTS:       sSourceIO:  INPUT/OUTPUT:   This string is an input output string
'               sSearchForString:           The string to search for and change
'               sReplacementString:         the string used to replace
' RETURNS:      the modified string as sSourceIO
' AUTHOR DATE:  brucej  04/18/96
' REV:          brucej/Sept ' 97
'********************************************************************************************************************
On Error GoTo ReplaceString_Err
Dim iPosition           As Integer          ' the position in the string that the object is located
Dim iLen                As Integer          ' the length of the object string
Dim x                   As Integer          ' errant trap
Dim s                   As String
'********************************************************************************************************************
    If Trim$(sSearchForString) = Trim$(sReplacementString) Then Exit Sub
    Do
        iPosition = InStr(sSourceIO, sSearchForString)
        If iPosition = 0 Then Exit Sub
        iLen = Len(sSearchForString)
        s = Left$(sSourceIO, iPosition - 1)               ' start of string
        s = s & sReplacementString                        ' insert the new target string
        s = s & Mid$(sSourceIO, iPosition + iLen)         ' get the end of the string
        sSourceIO = s
        x = x + 1
        If x > 1000 Then
            Err.Number = 9999
            Err.Description = "Runaway Do Loop"
            GoTo ReplaceString_Err
        End If
    Loop Until InStr(sSourceIO, sSearchForString) = 0
'********************************************************************************************************************
ReplaceString_bye:
    Exit Sub
ReplaceString_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "CountFilesInDirectory"
    Exit Sub
#End If
End Sub


Friend Sub PositionForm(frmCurrent As Form, frmNew As Form)
'***********************************************************************************************
' PURPOSE:      Will mirror the placement and size of an existing form
' INPUTS:       Will only position, not resize frmNew based on frmCurrent
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo PositionForm_Err:
'***********************************************************************************************

    frmNew.Move frmCurrent.Left, frmCurrent.Top
    frmCurrent.Hide
    frmNew.Show

'***********************************************************************************************
PositionForm_bye:
    Exit Sub
PositionForm_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "PositionForm"
    GoTo PositionForm_bye
#End If
End Sub

Friend Sub ShellAndWait(vstrApp As String)
'***********************************************************************************************
' PURPOSE:      to shell to an app, wait for it to finish and then come back
' EFFECTS:      the app shelled to and program execution here
' INPUTS:       vstrApp:  the path and file name to the shelled app
' AUTHOR DATE:  brucej
' REV:          brucej/01/24/96:  Slight memory leak if don't terminate process handle.  Added api and call.
'               brucej/09/26/96:  made more general - out of edi application
'***********************************************************************************************
On Error GoTo ShellAndWait_Err
Const INFINITE                      As Long = -1
Dim lngShellReturn                  As Long                     ' Return from Shell(), used in OpenProcess
Dim hOpenProcess                    As Long                     ' Return from OpenProcess, used in other function call
Dim lngExit                         As Long                     ' returned from GetExitCodeProcess
Dim lReturn                         As Long                     ' function return variable
'***********************************************************************************************
    lngShellReturn = Shell(vstrApp, vbHide)
    'lngShellReturn = Shell(vstrApp, vbNormal)
    hOpenProcess = OpenProcess(PROCESS_QUERY_INFORMATION + PROCESS_TERMINATE + SYNCHRONIZE, False, lngShellReturn)
    lReturn = WaitForSingleObject(hOpenProcess, INFINITE)
    lReturn = TerminateProcess(hOpenProcess, vbNull)
    lReturn = CloseHandle(hOpenProcess)
'***********************************************************************************************
ShellAndWait_bye:
    Exit Sub
ShellAndWait_Err:
    ErrorTrap Err.Number, Err.Description, "ShellAndWait"
    Exit Sub
End Sub

Sub Wait(bytSeconds As Byte)
'***********************************************************************************************
' PURPOSE:      will wait for passed number of secs
' AUTHOR DATE:  brucej
' REV:
'***********************************************************************************************
On Error GoTo Wait_Err:
'***********************************************************************************************
Dim lngTimer As Long

    lngTimer = Timer
    Do Until Timer - lngTimer > bytSeconds
        DoEvents
        If lngTimer > Timer Then lngTimer = Timer    ' adjust after midnight
    Loop

'***********************************************************************************************
Wait_bye:
    Exit Sub
Wait_Err:
#If debugme Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    ErrorTrap Err.Number, Err.Description, "Wait"
    GoTo Wait_bye
#End If
End Sub

