VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim sErrInfo        As String

Public Property Get ErrInfo() As String
    ErrInfo = sErrInfo
End Property

Private Property Let ErrInfo(ByVal sNewValue As String)
    sErrInfo = sNewValue
End Property

Public Function WriteFileFromString(sFileName As String, sFileContents As String) As String
    On Error GoTo ErrorHandler
    sErrInfo = vbNullString
    
    Const SUCCESS = 0
    Const FAILURE = -1
    Dim lBytesInFile        As Long
    Dim iFileNumber         As Integer

    iFileNumber = FreeFile
    Open sFileName For Binary Access Write As #iFileNumber
    '// lBytesInFile = LOF(iFileNumber)
    '// sFileContents = String(lBytesInFile, 0)
    Put #iFileNumber, , sFileContents
    Close #iFileNumber
    WriteFileFromString = SUCCESS
    
    Exit Function
ErrorHandler:
    sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Resume Next
End Function

Public Function ReadFileToString(sFileName As String) As String
    On Error GoTo ErrorHandler
    sErrInfo = vbNullString
    
    Dim lBytesInFile        As Long
    Dim iFileNumber         As Integer
    Dim sFileContents       As String
    
    iFileNumber = FreeFile
    Open sFileName For Binary Access Read As #iFileNumber
    lBytesInFile = LOF(iFileNumber)
    sFileContents = String(lBytesInFile, 0)
    Get #iFileNumber, , sFileContents
    Close #iFileNumber
    ReadFileToString = sFileContents
    
    Exit Function
ErrorHandler:
    sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Resume Next
End Function

Public Function ReadFileToByteA(sFileName As String) As Variant
    On Error GoTo ErrorHandler
    sErrInfo = vbNullString
    
    Dim lBytesInFile        As Long
    Dim iFileNumber         As Integer
    Dim sFileContents       As String
    Dim bFileContents()     As Byte
    
    iFileNumber = FreeFile
    Open sFileName For Binary Access Read As #iFileNumber
    lBytesInFile = LOF(iFileNumber)
    sFileContents = String(lBytesInFile, 0)
    Get #iFileNumber, , sFileContents
    Close #iFileNumber
    
    ReDim bFileContents(lBytesInFile)
    bFileContents = StrConv(sFileContents, vbFromUnicode)
    ReadFileToByteA = bFileContents
    
    Exit Function
ErrorHandler:
    sErrInfo = Err.Number - vbObjectError & ", " & Err.Description & ", " & Err.LastDllError
    Resume Next
End Function

Public Function ReadFromFile(sFileName As String) As String
    Dim iFileNumber As Integer
    Dim sFileContents As String
    iFileNumber = FreeFile  '// get next unused filenumber
    Open sFileName For Binary As #iFileNumber
    '// Open sFileName For Input Access Read Shared As #iFileNumber
    Get #iFileNumber, , sFileContents
    ReadFromFile = sFileContents
    Close #iFileNumber
End Function

Friend Function GetFileFromPath(sFullPath As String) As String
' returns the file from the full path
Dim iLen            As String
Dim icntr           As Integer

    iLen = Len(Trim$(sFullPath))
    For icntr = iLen To 1 Step -1
        If Mid$(sFullPath, icntr, 1) = "\" Then
            GetFileFromPath = Mid$(sFullPath, icntr + 1)
            Exit Function
        End If
    Next

End Function


Friend Function GetDirectoryFromPathFileName(sFullPath As String) As String
'Returns the path sans the file name
Dim iLen            As Integer
Dim icntr           As Integer
    
    iLen = Len(Trim$(sFullPath))
    For icntr = iLen To 1 Step -1
        If Mid$(sFullPath, icntr, 1) = "\" Then
            GetDirectoryFromPathFileName = Left$(sFullPath, icntr - 1)
            Exit Function
        End If
    Next
    
End Function

Friend Function AddBackSlash(vstrPath As String) As String
'****************************************************************************
' Purpose:  Will add backslash if not already there
' Author:   a-brucja(Volt)
'****************************************************************************
    vstrPath = Trim$(vstrPath)                      ' get rid of leading and traiLing spaces
    If Len(vstrPath) > 0 Then
        If Right$(vstrPath, 1) <> "\" Then
            vstrPath = vstrPath & "\"
        End If
    End If
    AddBackSlash = vstrPath
'****************************************************************************
End Function

Friend Function RemoveBackSlash(vstrPath As String, Optional bFront As Boolean) As String
' if bfront is true, take the the backslash off the front of the string

    vstrPath = Trim$(vstrPath)
    If Len(vstrPath) > 0 Then
        If bFront Then
            If Left$(vstrPath, 1) = "\" Then vstrPath = Mid$(vstrPath, 2)
        Else
            If Right$(vstrPath, 1) = "\" Then vstrPath = Left$(vstrPath, (Len(vstrPath) - 1))
        End If
    End If
    RemoveBackSlash = vstrPath
End Function
