VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Const SUCCESS = 0
Const FAILURE = -1

Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
 
Const LOCALE_USER_DEFAULT = &H400
Const LOCALE_SYSTEM_DEFAULT = &H800
Const DATE_LONGDATE = &H2
Const DATE_SHORTDATE = &H1

Const ROOT                      As Byte = 1
Const CURRENT_USER              As Byte = 2
Const LOCAL_MACHINE             As Byte = 3
Const USERS                     As Byte = 4

Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003
Const HKEY_PERFORMANCE_DATA = &H80000004
Const HKEY_CURRENT_CONFIG = &H80000005
Const HKEY_DYN_DATA = &H80000006

Const REG_OPTION_NON_VOLATILE   As Byte = 0
Const REG_NONE = 0
Const REG_SZ = 1
Const REG_EXPAND_SZ = 2
Const REG_BINARY = 3
Const REG_DWORD = 4
Const REG_DWORD_LITTLE_ENDIAN = 4
Const REG_DWORD_BIG_ENDIAN = 5
Const REG_LINK = 6
Const REG_MULTI_SZ = 7
Const REG_FULL_RESOURCE_DESCRIPTOR = 9

Const ERROR_SUCCESS = 0
Const ERROR_MORE_DATA = 234&
Const ERROR_NO_MORE_ITEMS = 259&
Const ERROR_FILE_NOT_FOUND = 2&
Const ERROR_BADDB               As Byte = 1
Const ERROR_BADKEY              As Byte = 2
Const ERROR_CANTOPEN            As Byte = 3
Const ERROR_CANTREAD            As Byte = 4
Const ERROR_CANTWRITE           As Byte = 5
Const ERROR_OUTOFMEMORY         As Byte = 6
Const ERROR_INVALID_PARAMETER   As Byte = 7
Const ERROR_ACCESS_DENIED       As Byte = 8
Const ERROR_INVALID_PARAMETERS  As Byte = 87

Const SYNCHRONIZE = &H100000
Const READ_CONTROL = &H20000
Const STANDARD_RIGHTS_ALL = &H1F0000
Const STANDARD_RIGHTS_REQUIRED = &HF0000
Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
Const KEY_READ = ( _
   (STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or _
    KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And _
   (Not SYNCHRONIZE))
Const KEY_WRITE = ( _
   (STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And _
   (Not SYNCHRONIZE))
Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))
Const KEY_ALL_ACCESS = ( _
   (STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or _
    KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or _
    KEY_NOTIFY Or KEY_CREATE_LINK) And _
   (Not SYNCHRONIZE))

Dim sErrInfo As String

Private Declare Function FileTimeToSystemTime Lib "kernel32" _
  (ByRef lpFileTime As FILETIME, ByRef lpSystemTime As SYSTEMTIME) As Long

Private Declare Function FileTimeToLocalFileTime Lib "kernel32" _
  (ByRef lpFileTime As FILETIME, ByRef lpLocalFileTime As FILETIME) As Long

Private Declare Function GetDateFormat Lib "kernel32" Alias "GetDateFormatA" _
  (ByVal Locale As Long, ByVal dwFlags As Long, lpDate As SYSTEMTIME, _
   ByVal lpFormat As String, ByVal lpDateStr As String, ByVal cchDate As Long _
  ) As Long

Private Declare Function RegConnectRegistry Lib "advapi32.dll" Alias "RegConnectRegistryA" _
                            (ByVal lpMachineName As String, _
                             ByVal mhKey As Long, _
                             phkResult As Long) As Long

Private Declare Function WNetCancelConnection2 Lib "mpr.dll" Alias "WNetCancelConnection2A" _
                            (ByVal lpName As String, _
                             ByVal dwFlags As Long, _
                             ByVal fForce As Long) As Long

Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" _
                            (ByVal mhKey As Long, _
                             ByVal lpSubKey As String, _
                             ByVal Reserved As Long, _
                             ByVal lpClass As String, _
                             ByVal dwOptions As Long, _
                             ByVal samDesired As Long, _
                             ByVal lpSecurityAttributes As Long, _
                             phkResult As Long, _
                             lpdwDisposition As Long) As Long

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
  (ByVal hKey As Long, ByVal szSubKey As String, ByVal ulOptions As Long, _
   ByVal samDesired As Long, ByRef lphKeyResult As Long _
  ) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, _
   ByVal szName As String, ByRef lpcbName As Long, _
   ByVal lpReserved As Long, _
   ByVal szClass As String, ByRef lpcbClass As Long, _
   ByRef lpLastWriteTime As FILETIME _
  ) As Long

Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" _
  (ByVal hKey As Long, ByVal szClass As String, ByRef lpcbClass As Long, _
   ByVal lpReserved As Long, ByRef lpcSubKeys As Long, ByRef lpcbMaxSubKeyLen As Long, _
   ByRef lpcbMaxClassLen As Long, ByRef lpcValues As Long, _
   ByRef lpcbMaxValueNameLen As Long, ByRef lpcbMaxValueLen As Long, _
   ByRef lpcbSecurityDescriptor As Long, ByRef lpftLastWriteTime As FILETIME _
  ) As Long

' Here is where the declares get a bit tricky.
' The registry enum/query/set APIs all require pointers as the data type
' To enable VB to automatically convert the data in all cases,
' declare different versions of these APIs.

' Make sure to use the correct alias for the data type you're using.

' To pass an address of a byte array, pass the address of the first byte:
' Dim lpData() As Byte
' ReDim lpData(dbData) As Byte
' Make the API call passing in lpData(1).

' RegEnumValueEx aliases:
Private Declare Function RegEnumValueByte Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, _
   ByVal szValueName As String, ByRef lpcbValueName As Long, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByRef lpData As Byte, ByRef lpcbData As Long _
  ) As Long

Private Declare Function RegEnumValueString Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, _
   ByVal szValueName As String, ByRef lpcbValueName As Long, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByVal lpData As String, ByRef lpcbData As Long _
  ) As Long

Private Declare Function RegEnumValueDword Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, _
   ByVal szValueName As String, ByRef lpcbValueName As Long, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByRef lpData As Long, ByRef lpcbData As Long _
  ) As Long

' RegQueryValueEx aliases:
Private Declare Function RegQueryValueExByte Lib "advapi32.dll" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByRef lpData As Byte, lpcbData As Long) As Long

Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByVal lpData As String, lpcbData As Long) As Long

Private Declare Function RegQueryValueExDword Lib "advapi32.dll" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByRef lpData As Long, lpcbData As Long) As Long
   
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByRef lpdwType As Long, ByVal lpData As Long, lpcbData As Long) As Long
      
' RegSetValueEx aliases:
Private Declare Function RegSetValueExByte Lib "advapi32.dll" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByVal dwType As Long, ByRef lpData As Byte, ByVal cbData As Long _
  ) As Long
  
Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long _
  ) As Long

Private Declare Function RegSetValueExDword Lib "advapi32.dll" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal szValueName As String, ByVal lpReserved As Long, _
   ByVal dwType As Long, ByRef lpData As Long, ByVal cbData As Long _
  ) As Long

' needed to convert REG_MULTI_SZ
Private Declare Function ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" _
  (ByVal szSrc As String, ByVal szDest As String, ByVal nSize As Long) As Long

Public Property Get ErrInfo() As String
    ErrInfo = sErrInfo
End Property

Private Property Let ErrInfo(ByVal sNewValue As String)
    sErrInfo = sNewValue
End Property

Public Function EnumValue(lKey As Long, sSubKey As String, oEnumList As Collection, Optional sRemoteMachineName As String) As Integer
    Dim lRet As Long
    Dim hKey As Long
    Dim cbClass As Long
    Dim cbName As Long
    Dim cbMaxSubKeyLen As Long
    Dim cbMaxClassLen As Long
    Dim cbMaxValueNameLen As Long
    Dim cbMaxValueLen As Long
    Dim cbSD As Long
    Dim cValues As Long
    Dim cSubKeys As Long
    
    Dim RegFileTime As FILETIME
    Dim LocalFileTime As FILETIME
    Dim LocalSystemTime As SYSTEMTIME
    
    Dim szTempFileDate As String * 256
    Dim szFileDate As String
    
    Dim dwIndex As Long
    Dim szName As String
    Dim szTempName As String
    Dim szClass As String
    Dim szTempClass As String
    Dim szData As String
    Dim szTempData As String
    Dim szExpandedData As String
    Dim lpData() As Byte
    Dim dwDataValue As Long
    Dim cbData As Long
    Dim dwDataType As Long
    
    ' variables needed to do REG_MULTI_SZ
    Dim i As Long
    Dim j As Long
    Dim count As Long
    Dim bExit As Long
    Dim szNullChar As String
    
    Dim fRemote As Boolean
    Dim lKeyHandle As Long
    Dim oRegEntry As New icuStoreCopy.cRegEntry
    
   '// lRet = RegOpenKeyEx(HKEY_CURRENT_USER, SubKey.Text, 0, KEY_READ, hKey)
   If (sRemoteMachineName <> vbNullString) Then
      Call FixRemoteMachineName(sRemoteMachineName)  '// add the wacks if not there
      fRemote = True
      lRet = RegConnectRegistry(sRemoteMachineName, lKey, lKeyHandle)
      If lRet <> ERROR_SUCCESS Then GoTo EnumValue_bye
   Else
      lKeyHandle = lKey
   End If
    
   lRet = RegOpenKeyEx(lKeyHandle, sSubKey, 0, KEY_ALL_ACCESS, hKey)
   
   If lRet = ERROR_FILE_NOT_FOUND Then
      '// Debug.Print lKey & "\" + sSubKey + " does not exist."
      Exit Function
   End If
   
   If Not lRet = ERROR_SUCCESS Then
      MsgBox "RegOpenKeyEx on " + lKey + "\" + sSubKey + _
         "returned " + Str(lRet)
      Exit Function
   End If
   
   ' First, find out how big szClass should be
   cbClass = 0
   lRet = RegQueryInfoKey(hKey, vbNullString, cbClass, 0, vbNull, vbNull, _
         vbNull, vbNull, vbNull, vbNull, vbNull, RegFileTime)
         
   If Not lRet = ERROR_SUCCESS Then
      MsgBox "First RegQueryInfoKey returned " + Str(lRet)
      RegCloseKey (hKey)
      Exit Function
   End If
   
   cbClass = cbClass + 1 ' extra room for C null terminator.  Don't want to fault.
   szTempClass = String(cbClass, "*") ' use *'s just to do error handling.
   
   ' now query all the information about the key, including max lengths
   lRet = RegQueryInfoKey(hKey, szTempClass, cbClass, 0, cSubKeys, cbMaxSubKeyLen, _
         cbMaxClassLen, cValues, cbMaxValueNameLen, cbMaxValueLen, cbSD, RegFileTime)
         
   If Not lRet = ERROR_SUCCESS Then
      MsgBox "Second RegQueryInfoKey returned " + Str(lRet)
      RegCloseKey (hKey)
      Exit Function
   End If
   
   ' szClass is valid once we strip off the unnecessary C null terminator
   szClass = Left(szTempClass, cbClass)
   
   ' convert the last accessed file time to something printable
   lRet = FileTimeToLocalFileTime(RegFileTime, LocalFileTime)
   lRet = FileTimeToSystemTime(LocalFileTime, LocalSystemTime)
   lRet = GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, LocalSystemTime, _
      vbNullString, szTempFileDate, 255)
   If lRet = 0 Then
      '// Debug.Print "GetDateFormat failed with " + Format(Error.LastDllError)
      szFileDate = "Data conversion failed"
   Else
      szFileDate = Left(szTempFileDate, lRet - 1)
   End If
      
   #If (DEBUGME) Then
        Select Case (lKey)
        Case HKEY_CLASSES_ROOT
           '// Debug.Print "HKEY_CLASSES_ROOT\" + sSubKey + " was last modified on " + szFileDate
        Case HKEY_CURRENT_USER
           '// Debug.Print "HKEY_CURRENT_USER\" + sSubKey + " was last modified on " + szFileDate
        Case HKEY_LOCAL_MACHINE
           '// Debug.Print "HKEY_LOCAL_MACHINE\" + sSubKey + " was last modified on " + szFileDate
        Case HKEY_USERS
           '// Debug.Print "HKEY_USERS\" + sSubKey + " was last modified on " + szFileDate
        End Select
        
        If Not cbClass = 0 Then
           '// Debug.Print "  and is of class: " + szClass
        End If
   #End If
   
   ' remember to include space for the C null terminators
   cbMaxSubKeyLen = cbMaxSubKeyLen + 1
   cbMaxValueNameLen = cbMaxValueNameLen + 1
   cbMaxClassLen = cbMaxClassLen + 1

   ' now enumerate the subkeys
   If Not cSubKeys = 0 Then
      #If (DEBUGME) Then
        '// Debug.Print "There are " + Str(cSubKeys) + " subkeys:"
      #End If
      
      dwIndex = 0
      
      ' get some buffer space for Win32 to return these strings
      szTempName = String(cbMaxSubKeyLen, "*")
      szTempClass = String(cbMaxClassLen, "*")
      
      Do
         cbName = cbMaxSubKeyLen
         cbClass = cbMaxClassLen
         lRet = RegEnumKeyEx(hKey, dwIndex, szTempName, cbName, _
            0, szTempClass, cbClass, RegFileTime)
            
         If lRet = ERROR_NO_MORE_ITEMS Then
            Exit Do
         End If
         
         If lRet = ERROR_MORE_DATA Then
            MsgBox "ERROR_MORE_DATA shouldn't happen.  Should have allocated enough space already."
            RegCloseKey (hKey)
            Exit Function
         End If
         
         If Not lRet = ERROR_SUCCESS Then
            MsgBox "RegEnumKeyEx failed with " + Str(lRet)
            RegCloseKey (hKey)
            Exit Function
         End If
         
         ' strip off the extra characters including the C null terminator
         szName = Left(szTempName, cbName)
         szClass = Left(szTempClass, cbClass)
            
         ' when was the last time the subkey was modified?
         lRet = FileTimeToLocalFileTime(RegFileTime, LocalFileTime)
         lRet = FileTimeToSystemTime(LocalFileTime, LocalSystemTime)
         lRet = GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, LocalSystemTime, _
            vbNullString, szTempFileDate, 255)
         If lRet = 0 Then
            '// Debug.Print "GetDateFormat failed with " + Format(Error.LastDllError)
            szFileDate = "Data conversion failed"
         Else
            szFileDate = Left(szTempFileDate, lRet - 1)
         End If
         
         #If (DEBUGME) Then
            '// Debug.Print "Subkey: " + szName + " was last modified on " + szFileDate
         #End If
         
         If Not cbClass = 0 Then
            '// Debug.Print "  and is of class: " + szClass
         End If
         
         dwIndex = dwIndex + 1
      Loop
      
   Else
      #If (DEBUGME) Then
        '// Debug.Print "No subkeys to enumerate"
      #End If
   End If
   
   If Not cValues Then
      dwIndex = 0
      
      ' get some buffer space for Win32 to return these strings
      ' note that this could be a different length than the key name buffers
      szTempName = String(cbMaxValueNameLen, "*")
      szTempData = String(cbMaxValueLen, "*")
      
      #If (DEBUGME) Then
        '// Debug.Print "There are " + Str(cValues) + " values:"
      #End If
      
      Do
         cbName = cbMaxValueNameLen
         cbData = 0
         
         ' find out what the data type is and get the name
         lRet = RegEnumValueString(hKey, dwIndex, szTempName, cbName, _
            0, dwDataType, vbNullString, cbData)
         
         If lRet = ERROR_NO_MORE_ITEMS Then
            Exit Do
         End If
         
         If Not ((lRet = ERROR_SUCCESS) Or (lRet = ERROR_MORE_DATA)) Then
            MsgBox "RegEnumValueName returned " + Str(lRet)
            RegCloseKey (hKey)
            Exit Function
         End If
         
         ' strip off the extra characters including the C terminator
         szName = Left(szTempName, cbName)
         
         ' must rest this value since it was modified by RegEnumValueString
         ' to *not* include room for the C terminator
         ' if we don't do this, RegEnumValue will complain about not enough space
         cbName = cbMaxValueNameLen
         
         ' now really get the data, depending on data type
         Select Case dwDataType
            Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
               lRet = RegEnumValueString(hKey, dwIndex, szTempName, cbName, _
                  0, dwDataType, szTempData, cbData)
                  
               If Not lRet = ERROR_SUCCESS Then
                  MsgBox "RegEnumValueString returned " + Str(lRet)
                  RegCloseKey (hKey)
                  Exit Function
               End If
               
               If dwDataType = REG_MULTI_SZ Then
                  szNullChar = Chr(0)
                  count = 1
                  i = 1
                  bExit = 0
                  #If (DEBUGME) Then
                    '// Debug.Print "Value " + szName + " = (REG_MULTI_SZ)"
                  #End If
                  While bExit = 0
                     j = InStr(i, szTempData, szNullChar, 0)
                     If j = i Then
                        bExit = 1
                     Else
                        szData = Mid(szTempData, i, j - i)
                        #If (DEBUGME) Then
                            '// Debug.Print "  Substring " + Format(count) + " = " + szData
                        #End If
                        i = j + 1
                        count = count + 1
                     End If
                  Wend
                 
               Else
                  szData = Left(szTempData, cbData)
                  #If (DEBUGME) Then
                    '// Debug.Print "Value " + szName + " = " + szData
                  #End If
                  oRegEntry.Name = szName
                  oRegEntry.RegType = dwDataType
                  oRegEntry.Data = szData
                  oRegEntry.Comment = "entry number " & dwIndex
                  Call oEnumList.Add(oRegEntry)
                  Set oRegEntry = Nothing
                  
                  
                  If dwDataType = REG_EXPAND_SZ Then
                     cbData = ExpandEnvironmentStrings(szData, vbNullString, 0)
                     szExpandedData = String(cbData, "*")
                     cbData = ExpandEnvironmentStrings(szData, szExpandedData, cbData)
                     
                     ' cbData returned is incorrect due to a bug in NT 4.0
                     ' the next 2 lines work around this bug
                     szNullChar = Chr(0)
                     cbData = InStr(1, szExpandedData, szNullChar, 0)
                     
                     szData = Left(szExpandedData, cbData)
                     #If (DEBUGME) Then
                        '// Debug.Print "  Expanded = " + szData
                     #End If
                  End If
               End If
               
            Case REG_DWORD
               lRet = RegEnumValueDword(hKey, dwIndex, szTempName, cbName, _
                  0, dwDataType, dwDataValue, cbData)
                  
               If Not lRet = ERROR_SUCCESS Then
                  MsgBox "RegEnumValueDword returned " + Str(lRet)
                  RegCloseKey (hKey)
                  Exit Function
               End If
               
               #If (DEBUGME) Then
                 '// Debug.Print "Value " + szName + " = (DWORD) " + Str(dwDataValue)
               #End If
               
            Case Else
               ReDim lpData(cbData) As Byte
               lRet = RegEnumValueByte(hKey, dwIndex, szTempName, cbName, _
                  0, dwDataType, lpData(1), cbData)
                  
               If Not lRet = ERROR_SUCCESS Then
                  MsgBox "RegEnumValueByte returned " + Str(lRet)
                  RegCloseKey (hKey)
                  Exit Function
               End If
               
               #If (DEBUGME) Then
                    Select Case dwDataType
                       Case REG_NONE
                          '// Debug.Print "Value " + szName + _
                             " = (NONE) " + Str(cbData) + " bytes not printed "
                       Case REG_BINARY
                          '// Debug.Print "Value " + szName + _
                             " = (BINARY) " + Str(cbData) + " bytes not printed "
                       Case REG_DWORD_BIG_ENDIAN
                          '// Debug.Print "Value " + szName + _
                             " = (BIG ENDIAN DWORD) " + Str(cbData) + " bytes not printed "
                       Case REG_LINK
                          '// Debug.Print "Value " + szName + _
                             " = (LINK) " + Str(cbData) + " bytes not printed "
                       Case REG_FULL_RESOURCE_DESCRIPTOR
                          '// Debug.Print "Value " + szName + _
                             " = (RESOURCE) " + Str(cbData) + " bytes not printed "
                       Case Else
                          '// Debug.Print "Value " + szName + _
                             " = (UNKNOWN) " + Str(cbData) + " bytes not printed "
                    End Select
               #End If
               
         End Select
         
         dwIndex = dwIndex + 1
      Loop
    
   Else
      #If (DEBUGME) Then
        '// Debug.Print "No values to enumerate"
      #End If
   End If
        
    '// EnumValue = colValues
    EnumValue = SUCCESS
    
'********************************************************************************************************************
EnumValue_bye:
    RegCloseKey (hKey)
    If fRemote Then
        RegCloseKey (lKeyHandle)
        Call WNetCancelConnection2(sRemoteMachineName & "\ipc$", 0, True)  'not going to error trap here
    End If
    If lRet Then
        EnumValue = FAILURE                         ' for this method, a null string means error
        sErrInfo = GetReturnMessageString(lRet)                ' sets the error property
    Else
        EnumValue = SUCCESS
    End If
End Function

Private Function GetReturnMessageString(lRetVal As Long) As String
'********************************************************************************************************************
'PURPOSE:       to return a string with success or error information
'INPUTS:        lRetVal:    the return long from the api call
'OUTPUTS:       the string
'AUTHOR:        a-brucja/07/24/96
'********************************************************************************************************************
    Select Case lRetVal
        Case ERROR_SUCCESS:             GetReturnMessageString = "Success"
        Case ERROR_BADDB:               GetReturnMessageString = "Error: Bad Database"
        Case ERROR_BADKEY:              GetReturnMessageString = "Error: Bad Key"
        Case ERROR_CANTOPEN:            GetReturnMessageString = "Error: Can't Open"
        Case ERROR_CANTREAD:            GetReturnMessageString = "Error: Can't Read"
        Case ERROR_CANTWRITE:           GetReturnMessageString = "Error: Can't Write"
        Case ERROR_OUTOFMEMORY:         GetReturnMessageString = "Error: Out of Memory"
        Case ERROR_INVALID_PARAMETER:   GetReturnMessageString = "Error: Invalid Parameter"
        Case ERROR_ACCESS_DENIED:       GetReturnMessageString = "Error: Access is Denied"
        Case ERROR_INVALID_PARAMETERS:  GetReturnMessageString = "Error: Invalid Parameters"
        Case ERROR_NO_MORE_ITEMS:       GetReturnMessageString = "Error: No More Items"
        Case Else:                      GetReturnMessageString = "Error: Unspecified"
    End Select
'********************************************************************************************************************
End Function


Private Function FriendlyToConst(bytFriendly As Byte) As Long
'*************************************************************************************************************
' takes the friendly byte value for the key and returns the long const value
'*************************************************************************************************************
    Select Case bytFriendly
        Case ROOT:           FriendlyToConst = HKEY_CLASSES_ROOT
        Case CURRENT_USER:   FriendlyToConst = HKEY_CURRENT_USER
        Case USERS:          FriendlyToConst = HKEY_USERS
        Case LOCAL_MACHINE:  FriendlyToConst = HKEY_LOCAL_MACHINE
    End Select
'*************************************************************************************************************
End Function


Private Function SetValueEx(ByVal hKey As Long, sValueName As String, lType As Long, vValue As Variant) As Long
'********************************************************************************************************************
Dim lValue As Long
Dim sValue As String
'********************************************************************************************************************
    Select Case lType
        Case REG_SZ
            sValue = vValue
            SetValueEx = RegSetValueExString(hKey, sValueName, 0, lType, sValue, Len(sValue))
        Case REG_DWORD
            lValue = vValue
        SetValueEx = RegSetValueExDword(hKey, sValueName, 0, lType, lValue, 4)
    End Select
'********************************************************************************************************************
End Function
 

Private Function QueryValueEx(ByVal lhKey As Long, ByVal sValueName As String, vValue As Variant) As Long
'********************************************************************************************************************
Dim lBuffSize               As Long               ' data buffer size
Dim lReturn                 As Long
Dim lType                   As Long               ' address of buffer for value type
Dim lValue                  As Long               ' return value if dword or long
Dim sValue                  As String             ' return value if string
On Error GoTo QueryValueExError
'********************************************************************************************************************
    ' Determine the size and type of data to be read
    lReturn = RegQueryValueExNULL(lhKey, sValueName, 0, lType, 0, lBuffSize)
    If lReturn <> ERROR_SUCCESS Then GoTo QueryValueExExit
    Select Case lType
        Case REG_SZ                        ' For strings
            sValue = String(lBuffSize, 0)     ' pad the buffer with nulls
            lReturn = RegQueryValueExString(lhKey, sValueName, 0, lType, sValue, lBuffSize)
            If lReturn = ERROR_SUCCESS Then
                vValue = Left$(sValue, lBuffSize)
            Else
                vValue = Empty
            End If
        Case REG_DWORD                       ' For DWORDS
            lReturn = RegQueryValueExDword(lhKey, sValueName, 0, lType, lValue, lBuffSize)
            If lReturn = ERROR_SUCCESS Then vValue = lValue
        Case Else
            lReturn = True
    End Select
'********************************************************************************************************************
QueryValueExExit:
    QueryValueEx = lReturn
    Exit Function
QueryValueExError:
    #If DEBUGME Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
    QueryValueEx = True
    Exit Function
#End If
End Function

Private Sub QueryValue(sKeyName As String, sValueName As String)
'********************************************************************************************************************
Dim lRetVal As Long          'result of the API functions
Dim hKey As Long             'handle of opened key
Dim vValue As Variant        'setting of queried value
'********************************************************************************************************************
       lRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, sKeyName, 0, KEY_ALL_ACCESS, hKey)
       lRetVal = QueryValueEx(hKey, sValueName, vValue)
       RegCloseKey (hKey)
'********************************************************************************************************************
End Sub

Private Sub FixRemoteMachineName(sRemoteMachineName As String)
'********************************************************************************************************************
' Purpose:  need to make sure we have the double wacks in front of the string; i.e.: \\brucej1
' the sRemoteMachineName is an i/o param
'********************************************************************************************************************
Const DOUBLE_WACKS      As String = "\\"
Const WACK              As String = "\"
'********************************************************************************************************************
    sRemoteMachineName = Trim$(sRemoteMachineName)

    If Left$(sRemoteMachineName, 2) = DOUBLE_WACKS Then Exit Sub
    
    If Left$(sRemoteMachineName, 1) = WACK Then
        sRemoteMachineName = WACK & sRemoteMachineName
        Exit Sub
    End If
    
    sRemoteMachineName = DOUBLE_WACKS & sRemoteMachineName
   
'********************************************************************************************************************
End Sub

Public Function CheckForKey(bytKeyName As Byte, sSubKey As String, Optional sRemoteMachineName As String) As Boolean
' Purpose:  this method will check for the existence of the key on a local or remote machine.
' Returns:  true if key is NOT found or Error
'           false if key IS found

'           IF RETURNS TRUE, MUST CHECK THE sErrInfo PROPERTY TO VERIFY RETURNS "BAD KEY"
'********************************************************************************************************************
Dim hKey                As Long                             ' handle to the reg key
Dim lRetVal             As Long                             ' result of the RegCreateKeyEx function
Dim lKey                As Long                             ' the derived key number
Dim fRemote             As Boolean                          ' true if calling a remote server
Dim lKeyHandle          As Long                             ' handle to the remote machine
'********************************************************************************************************************
    sErrInfo = False
    
    lKey = FriendlyToConst(bytKeyName)                      ' takes the friendly name and returns the hex value we need
    
    If sRemoteMachineName <> vbNullString Then
        Call FixRemoteMachineName(sRemoteMachineName)       ' add the wacks if not there
        fRemote = True
        lRetVal = RegConnectRegistry(sRemoteMachineName, lKey, lKeyHandle)
        If lRetVal <> ERROR_SUCCESS Then GoTo CheckForKey_Bye
    Else
        lKeyHandle = lKey
    End If
    
    ' Reg OpenKey will not create key if not there and so is suitable for this method
    lRetVal = RegOpenKeyEx(lKeyHandle, sSubKey, 0, KEY_ALL_ACCESS, hKey)
    
'********************************************************************************************************************
CheckForKey_Bye:
    
    On Error Resume Next
    
    RegCloseKey (hKey)
    
    If fRemote Then
        RegCloseKey (lKeyHandle)
        Call WNetCancelConnection2(sRemoteMachineName & "\ipc$", 0, True)  'not going to error trap here
    End If
    
    If lRetVal Then
        CheckForKey = True
        sErrInfo = GetReturnMessageString(lRetVal)                ' sets the public property
    Else
        CheckForKey = False
    End If

End Function

Public Function CreateNewKey(bytKeyName As Byte, sSubKey As String, Optional sRemoteMachineName As String) As Boolean
'********************************************************************************************************************
' PURPOSE:  to create a new key in the registry
' INPUTS:   bytKeyName:         ROOT = 1
'                               CURRENT_USER = 2
'                               LOCAL_MACHINE = 3
'                               USERS = 4
'          sSubKey:             the subkey to create
'          sRemoteMachineName:  optional machine name
' EXAMPLE: #1
'          IF you call this function with:           CreateNewKey 2, "TestKey"
'          this function will create a key called TestKey immediately under HKEY_CURRENT_USER.
'          #2
'          Calling CreateNewKey Like this            CreateNewKey 2, "TestKey\SubKey1\SubKey2"
'          will create a three-nested keys beginning with TestKey immediately under
'          HKEY_CURRENT_USER, SubKey1 subordinate to TestKey, and SubKey3 under  SubKey2.
' OUTPUT:  True if error - otherwise false
' AUTHOR:  a-brucja/07/24/96
' rev:     a-brucej 9/23/97:  added support for remote machine access
'                             also added sErrInfo property so for this method, error string is also returned
'                               might make more sense to make this function call a boolean, but keep it like this for
'                               backwards compatibility
'********************************************************************************************************************
Dim hNewKey             As Long                             ' handle to the new key
Dim lRetVal             As Long                             ' result of the RegCreateKeyEx function
Dim lKey                As Long                             ' the derived key number
Dim fRemote             As Boolean                          ' true if calling a remote server
Dim lKeyHandle          As Long                             ' handle to the remote machine
'********************************************************************************************************************
    sErrInfo = False
    
    lKey = FriendlyToConst(bytKeyName)                      ' takes the friendly name and returns the hex value we need
    
    If sRemoteMachineName <> vbNullString Then
        Call FixRemoteMachineName(sRemoteMachineName)       ' add the wacks if not there
        fRemote = True
        lRetVal = RegConnectRegistry(sRemoteMachineName, lKey, lKeyHandle)
        If lRetVal <> ERROR_SUCCESS Then GoTo CreateNewKey_bye
    Else
        lKeyHandle = lKey
    End If
        
    lRetVal = RegCreateKeyEx(lKeyHandle, _
                             sSubKey, _
                             0&, _
                             vbNullString, _
                             REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, _
                             0&, _
                             hNewKey, _
                             lRetVal)
    
'********************************************************************************************************************
CreateNewKey_bye:
    
    On Error Resume Next
    
    RegCloseKey (hNewKey)
    
    If fRemote Then
        RegCloseKey (lKeyHandle)
        Call WNetCancelConnection2(sRemoteMachineName & "\ipc$", 0, True)  'not going to error trap here
    End If
    
    If lRetVal Then
        CreateNewKey = True
        sErrInfo = GetReturnMessageString(lRetVal)                ' sets the public property
    Else
        CreateNewKey = False
    End If
    
End Function

Public Function QueryStringValue(bytKeyName As Byte, sSubKey As String, sValueName As String, Optional sRemoteMachineName As String) As String
'********************************************************************************************************************
' PURPOSE:      will return the string value from the key and subkey passed here
' EFFECTS:      the return is a value or error message

' INPUTS:       bytKeyName:     ROOT = 1
'                               CURRENT_USER = 2
'                               LOCAL_MACHINE = 3
'                               USERS = 4
'               sSubKey:        name of the subkey
'               sValueName:     if any
' optional sRemoteMachineName:  figure it out

' RETURNS:      error message or vbnullstring if no problem
'               the vReturnValue string holds return string or dword value
' CALLED FROM:
' AUTHOR DATE:  a-brucja 09/17/96
' rev:          a-brucej 09/23/97 added remote machine stuff
'********************************************************************************************************************
Dim lRetVal                         As Long             'long return value from function call
Dim lKey                            As Long             'pointer to the open key
Dim hKey                            As Long             'handle of opened key
Dim vValue                          As Variant          'setting of queried value
Dim sErrInfo                          As String           'error message
Dim fRemote                         As Boolean
Dim lKeyHandle                      As Long
'********************************************************************************************************************
    sErrInfo = False
    
    lKey = FriendlyToConst(bytKeyName)
    
    If sRemoteMachineName <> vbNullString Then
        Call FixRemoteMachineName(sRemoteMachineName)       ' add the wacks if not there
        fRemote = True
        lRetVal = RegConnectRegistry(sRemoteMachineName, lKey, lKeyHandle)
        If lRetVal <> ERROR_SUCCESS Then GoTo QueryStringValue_bye
    Else
        lKeyHandle = lKey
    End If
    
    lRetVal = RegOpenKeyEx(lKeyHandle, sSubKey, 0, KEY_ALL_ACCESS, hKey)
    
    If lRetVal = ERROR_SUCCESS Then
        lRetVal = QueryValueEx(hKey, sValueName, vValue)
    End If
    
'********************************************************************************************************************
QueryStringValue_bye:
    
    RegCloseKey (hKey)
    
    If fRemote Then
        RegCloseKey (lKeyHandle)
        Call WNetCancelConnection2(sRemoteMachineName & "\ipc$", 0, True)  'not going to error trap here
    End If
    
    If lRetVal Then
        QueryStringValue = vbNullString                         ' for this method, a null string means error
        sErrInfo = GetReturnMessageString(lRetVal)                ' sets the error property
    Else
        QueryStringValue = CStr(vValue)
    End If
 
 End Function

Public Function SetKeyValue(bytKey As Byte, _
                              sSubKey As String, _
                              sValueName As String, _
                              vNewValue As Variant, _
                              lValueType As Long, _
                              Optional sRemoteMachineName As String) As Boolean
'********************************************************************************************************************
' PURPOSE:      the method that adds or modifies a value to an existing reg key

' INPUTS:       bytKey:         the key or key/subkey... vaule to set
'               sValueName:     The StringName to change the value
'               vNewValue:      The new setting
'               lValueType:     The type, string
' optional sRemoteMachineName:  duh

' RETURNS:      Can return either error string or true if error
' ex:     If cReg.SetKeyValue _
                        (bytKey:=3, _
                         sSubKey:=REG_WWW_PARAMETERS, _
                         sValueName:="Authorization", _
                         vNewValue:=bytValue, _
                         lValueType:=4, _
                         sRemoteMachineName:="\\icu2") then...

'********************************************************************************************************************
Dim hKey                As Long                             ' handle to the new key
Dim lRetVal             As Long                             ' result of the RegCreateKeyEx function
Dim lKey                As Long                             ' the derived key number
Dim sMsg                As String                           ' error message
Dim fRemote             As Boolean                          ' true if calling a remote server
Dim lKeyHandle          As Long                             ' handle to the remote machine
'********************************************************************************************************************
    sErrInfo = False
    
    lKey = FriendlyToConst(bytKey)                      ' takes the friendly name and returns the hex value we need
    
    If sRemoteMachineName <> vbNullString Then
        Call FixRemoteMachineName(sRemoteMachineName)       ' add the wacks if not there
        fRemote = True
        lRetVal = RegConnectRegistry(sRemoteMachineName, lKey, lKeyHandle)
        If lRetVal <> ERROR_SUCCESS Then GoTo SetKeyValue_bye
    Else
        lKeyHandle = lKey
    End If

    lRetVal = RegOpenKeyEx(lKeyHandle, sSubKey, 0, KEY_ALL_ACCESS, hKey)
    If lRetVal <> ERROR_SUCCESS Then GoTo SetKeyValue_bye
    
    lRetVal = SetValueEx(hKey, sValueName, lValueType, vNewValue)
    If lRetVal <> ERROR_SUCCESS Then GoTo SetKeyValue_bye
    
'********************************************************************************************************************
SetKeyValue_bye:
    
    On Error Resume Next
    
    RegCloseKey (hKey)
    
    If fRemote Then
        RegCloseKey (lKeyHandle)
        Call WNetCancelConnection2(sRemoteMachineName & "\ipc$", 0, True)  'not going to error trap here
    End If

    If lRetVal Then
        SetKeyValue = True
        sErrInfo = GetReturnMessageString(lRetVal)                ' sets the error property
    Else
        SetKeyValue = False
    End If

End Function

