VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cUtility"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const SUCCESS = 0
Const FAILURE = -1
Const MSG_CAPTION As String = "Store Move Wizard"
Const PROCESS_QUERY_INFORMATION As Long = &H400
Const PROCESS_TERMINATE As Long = &H1
Const STILL_ACTIVE As Long = &H103
Const SYNCHRONIZE As Long = 1048576

Dim iRet As Integer

Private Declare Function CloseHandle _
             Lib "kernel32" _
                    (ByVal hObject As Long) As Long

Private Declare Function OpenProcess _
            Lib "kernel32" _
                    (ByVal dwDesiredAccess As Long, _
                     ByVal bInheritHandle As Long, _
                     ByVal dwProcessId As Long) As Long
                     
Private Declare Function GetExitCodeProcess _
            Lib "kernel32" _
                    (ByVal hProcess As Long, _
                    lpExitCode As Long) As Long

Private Declare Function TerminateProcess _
            Lib "kernel32" _
                    (ByVal hProcess As Long, _
                    ByVal uExitCode As Long) As Long

Private Declare Function api_GetPrivateProfileString_StringKey _
                                    Lib "kernel32" Alias "GetPrivateProfileStringA" _
                                                (ByVal lpApplicationName As String, _
                                                 ByVal lpKeyName As String, _
                                                 ByVal lpDefault As String, _
                                                 ByVal lpReturnedString As String, _
                                                 ByVal nSize As Long, _
                                                 ByVal lpFileName As String) As Long

Private Declare Function api_WritePrivateProfileString _
                                    Lib "kernel32" Alias "WritePrivateProfileStringA" _
                                                (ByVal lpApplicationName As String, _
                                                 ByVal lpKeyName As Any, _
                                                 ByVal lpString As String, _
                                                 ByVal lpFileName As String) As Long

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function WaitForSingleObject _
                                    Lib "kernel32" _
                                    (ByVal hHandle As Long, _
                                     ByVal dwMilliseconds As Long) As Long


Public Sub CenterMe(frm As Object)
' Purpose:  will center on screen the form passed here
' call like centerme(me)
frm.Move (Screen.Width - frm.Width) / 2, (Screen.Height - frm.Height) / 2
End Sub

Public Sub MirrorForm(frmCurrent As Object, frmNew As Object)
' Purpose:  Will mirror the placement and size of an existing form
    '//frmNew.Move frmCurrent.Left, frmCurrent.Top, frmCurrent.Width, frmCurrent.Height
    frmNew.Move frmCurrent.Left, frmCurrent.Top
    frmCurrent.Hide
    frmNew.Show
End Sub

Public Function ValidateBox(frmCall As Object, ctrlTextBox As Object) As Boolean
' Returns TRUE if Error
' Will validate that the field passed here has something in it.  Uses the tag field to id
    If ctrlTextBox = vbNullString Then
        MsgBox "You must enter a value in the " & ctrlTextBox.Tag & " field.", vbOKOnly, MSG_CAPTION
        frmCall.Controls(ctrlTextBox.Name).SetFocus
        ValidateBox = True
    End If
End Function

Public Function ReadIniFile _
                                (r_sAppName As String, _
                                 r_sKeyName As String, _
                                 r_sDefaultValue As String, _
                                 r_sIniFileName As String) As String
'********************************************************************************************************************
' PURPOSE:      reads ini file information
' EFFECTS:      nothing
' INPUTS:       r_sAppName:         section header
'               r_skeyName:         the entry whose associated string is to be retrieved
'               r_sDefaultValue:    in case there is nothing in the registry, this will be the default
'               r_sIniFileName:     and path if necessary
' RETURNS:      the string value from the ini file
' CALLED FROM:  several places
' AUTHOR DATE:  a-brucja 07/10/96
'********************************************************************************************************************
Dim sReturn                     As String * 4098
Dim l                           As Long
On Error GoTo ReadIniFile_Err
'********************************************************************************************************************
    l = api_GetPrivateProfileString_StringKey(lpApplicationName:=r_sAppName, lpKeyName:=r_sKeyName, _
            lpDefault:=r_sDefaultValue, lpReturnedString:=sReturn, nSize:=4099, lpFileName:=r_sIniFileName)
    If l > 0 Then
        ReadIniFile = Left$(sReturn, l)
    Else
        ReadIniFile = vbNullString
    End If
'********************************************************************************************************************
ReadIniFile_bye:
    Exit Function
ReadIniFile_Err:
#If DEBUGME Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
'    ErrorTrap r_lngErrorNumber:=Err.Number, r_strErrorDescription:=Err.Description, r_strCallingFunction:="ReadIniFile"
    Exit Function
#End If
End Function

Public Function WriteIniFile _
                                (r_sAppName As String, _
                                 r_sKeyName As String, _
                                 r_sString As String, _
                                 r_sIniFileName As String) As Boolean
'********************************************************************************************************************
' PURPOSE:      writes ini file information
' EFFECTS:      nothing
' INPUTS:       r_sAppName:         section header
'               r_skeyName:         the entry whose associated string is to be retrieved
'               r_sString:          string to write
'               r_sIniFileName:     and path if necessary
' RETURNS:      true if succcess
' CALLED FROM:  several places
' AUTHOR DATE:  a-brucja 09/26/96
'********************************************************************************************************************
Dim sReturn                     As String * 2048
Dim l                           As Long
On Error GoTo WriteIniFile_Err
'********************************************************************************************************************
    l = api_WritePrivateProfileString _
                                (lpApplicationName:=r_sAppName, _
                                 lpKeyName:=r_sKeyName, _
                                 lpString:=r_sString, _
                                 lpFileName:=r_sIniFileName)
    
    If l > 0 Then WriteIniFile = True
'********************************************************************************************************************
WriteIniFile_bye:
    Exit Function
WriteIniFile_Err:
#If DEBUGME Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
'    ErrorTrap r_lngErrorNumber:=Err.Number, r_strErrorDescription:=Err.Description, r_strCallingFunction:="WriteIniFile"
    Exit Function
#End If
End Function

Public Function ParseToken(vstrString As String, vstrToken As String) As String
'***********************************************************************************************
' PURPOSE:      To parse a strString for the string to the vstrToken.  A common use for this would
' be a routine that would work like this:
'-----------------------------------------------------
'    Do until strSearchString = ""
'        Array(x) = ParseToken(strSearchString,";")
'    Loop
'-----------------------------------------------------
' or a better way is to use collections as:
'    Do Until s = vbNullString
'        cFiles.Add (ParseToken(s, vbNullChar))
'    Loop
'This function will change the value of strString each time it is called so should place any value
'that you need to keep the original in a temp string and pass the temp string
'*************************************************************************************************
' EFFECTS:      vstrString, changes it each time the program runs
' INPUTS:       vstrString:  string that has the values and tokens
'               vstrToken:  token value; e.g., ; or , or anything
' RETURNS:      The value before the token
' CALLED FROM:  Page
' AUTHOR DATE:  a-brucja 08/25/95
'***********************************************************************************************
Dim i As Integer
'***********************************************************************************************
    i = InStr(1, vstrString, vstrToken, 1)             ' case insenstive
    If i > 0 Then
        ParseToken = Left$(vstrString, i - 1)
        vstrString = Mid$(vstrString, i + 1)
    Else
        ParseToken = vstrString
        vstrString = vbNullString
    End If
'***********************************************************************************************
End Function

Public Sub StripNull(s As String)
'**********************************************************************************
' strips trailing null if found
Dim iLen            As Integer
'**********************************************************************************
    iLen = Len(s)
    If Right$(s, 1) = vbNullChar Then s = Left$(s, iLen - 1)
'**********************************************************************************
End Sub


Public Sub ReplaceString(r_sSourceIO As String, r_sObject As String, r_sTarget As String)
'********************************************************************************************************************
' PURPOSE:      Changes the source string by replacing all of the target strings with objects
' EFFECTS:      the given string
' INPUTS:       r_sSourceIO:  INPUT/OUTPUT:   This string is an input output string
'               r_sOjbect:                    The string to search for and change
'               r_sTarget:                    the string to replace
' RETURNS:      the modified string as r_sSourceIO
' CALLED FROM:
' AUTHOR DATE:  a-brucja   04/18/96
'********************************************************************************************************************
On Error GoTo ReplaceString_Err
Dim iPosition           As Integer          ' the position in the string that the object is located
Dim iLen                As Integer          ' the length of the object string
Dim s                   As String           ' temp string variable
Dim x                   As Integer          ' errant trap
'********************************************************************************************************************
    If Trim$(r_sObject) = Trim$(r_sTarget) Then Exit Sub
    Do
        iPosition = InStr(r_sSourceIO, r_sObject)
        If iPosition = 0 Then Exit Sub
        iLen = Len(r_sObject)
        s = Left$(r_sSourceIO, iPosition - 1)               ' start of string
        s = s & r_sTarget                                   ' insert the new target string
        s = s & Mid$(r_sSourceIO, iPosition + iLen)         ' get the end of the string
        r_sSourceIO = s
        x = x + 1
        If x > 1000 Then
            Err.Number = 9999
            Err.Description = "Runaway Do Loop"
            GoTo ReplaceString_Err
        End If
    Loop Until InStr(r_sSourceIO, r_sObject) = 0
'********************************************************************************************************************
ReplaceString_bye:
    Exit Sub
ReplaceString_Err:
#If DEBUGME Then
    Stop
    MsgBox "ErrNumber: " & CStr(Err.Number) & vbCrLf & "ErrMessage: " & Err.Description
    Resume
#Else
'    ErrorTrap r_lngErrorNumber:=Err.Number, r_strErrorDescription:=Err.Description, r_strCallingFunction:="CountFilesInDirectory"
    Exit Sub
#End If
End Sub


Public Sub PositionForm(frmCurrent As Object, frmNew As Object)
' Purpose:  Will mirror the placement and size of an existing form
    frmNew.Move frmCurrent.Left, frmCurrent.Top
    frmCurrent.Hide
    frmNew.Show
End Sub

Public Sub ShellAndWait(vstrApp As String)
'***********************************************************************************************
' PURPOSE:      to shell to an app, wait for it to finish and then come back
' EFFECTS:      the app shelled to and program execution here
' INPUTS:       vstrApp:  the path and file name to the shelled app
' RETURNS:      Nothing
' CALLED FROM:  Several modules
' AUTHOR DATE:  a-brucja
' REV:          a-brucja; 01/24/96:  Slight memory leak if don't terminate process handle.  Added api and call.
'               a-brucja  09/26/96:  made more general - out of edi application
'***********************************************************************************************
On Error GoTo ShellAndWait_Err
Const INFINITE                      As Long = -1
Dim lngShellReturn                  As Long                     ' Return from Shell(), used in OpenProcess
Dim hOpenProcess                    As Long                     ' Return from OpenProcess, used in other function call
Dim lngExit                         As Long                     ' returned from GetExitCodeProcess
Dim lReturn                         As Long                     ' function return variable
'***********************************************************************************************
    lngShellReturn = Shell(vstrApp, vbHide)
    'lngShellReturn = Shell(vstrApp, vbNormal)
    hOpenProcess = OpenProcess(PROCESS_QUERY_INFORMATION + PROCESS_TERMINATE + SYNCHRONIZE, False, lngShellReturn)
    lReturn = WaitForSingleObject(hOpenProcess, INFINITE)
    lReturn = TerminateProcess(hOpenProcess, vbNull)
    lReturn = CloseHandle(hOpenProcess)
'***********************************************************************************************
ShellAndWait_bye:
    Exit Sub
ShellAndWait_Err:
'    ErrorTrap r_lngErrorNumber:=Err.Number, r_strErrorDescription:=Err.Description, r_strCallingFunction:="ShellAndWait"
    Exit Sub
End Sub

Public Function Pause(iPauseTime As Integer) As Integer
    Dim iStart, iFinish, iTotalTime As Integer
    iStart = Timer  '// Set start time.
    While (Timer < iStart + iPauseTime)
        DoEvents  '// Yield to other processes.
        '// whatever else you want
    Wend
    iFinish = Timer  '// Set end time.
    iTotalTime = iFinish - iStart  '// Calculate total time.
    Pause = SUCCESS  '// return SUCCESS
End Function

Public Function MakeNetPath(sServer As String, sPath As String) As String
    '// replace <drive:> with <drive$> to create network path
    
    iRet = InStr(1, sPath, ":", vbBinaryCompare)
    MakeNetPath = "\\" & sServer & "\" & _
                  Left(sPath, iRet - 1) & "$" & Mid(sPath, iRet + 1)
End Function

